/*
 * Nspire text viewer
 * View test.tns as an ASCII file
 * This code sucks
 * Don't code like it
 * I'm lazy :(
 */

#include <os.h>
#include "utils.h"
#include "screen.h"
#include "dirlist.h"
#include "string.h"

asm(".string \"PRG\"\n");

int main(void) 
{
  char* scrbuf;
  char* tmpbuf;
  char* filebuf;
  char** filenames;
  int size, numfiles;
  FILE* file;
  char* selected;
  char* path;
  char* name;
  int x, y, i, current;
  char ch;
  filenames = (char**) malloc(1024);
  scrbuf = (char*) malloc(SCREEN_BYTES_SIZE);
  tmpbuf = (char*) malloc(SCREEN_BYTES_SIZE);
  clearBuf(scrbuf);
  numfiles = dirlist("/documents/Examples/", "*.txt.tns", filenames);
  y = 0;
  for (i = 0; i < numfiles; i++) {
    drawStr(scrbuf, 8, y, filenames[i]);
    y += 12;
  } 
  refresh(scrbuf);
  i = 0;
  while (!isKeyPressed(KEY_NSPIRE_CLICK)) {
    if (isKeyPressed(KEY_NSPIRE_UP)) {
      putChar(scrbuf, 0, 12 * i, 0);
      i--;
      if (i < 0) i = 0;
    }
    if (isKeyPressed(KEY_NSPIRE_DOWN)) {
      putChar(scrbuf, 0, 12 * i, 0);
      i++;
      if (i >= numfiles) i = numfiles - 1;
    }
    if (isKeyPressed(KEY_NSPIRE_ESC)) {
      return 0;
    }
    drawStr(scrbuf, 0, 12 * i, ">");
    //refresh 3x to delay keypresses
    for (y = 0; y < 3; y++) {
      refresh(scrbuf);
    }
  }
  selected = filenames[i]; 
  path = "/documents/Examples/";
  name = (char*) malloc(strlen(path) + strlen(selected));
  strcpy(name, path);
  strcpy(name + strlen(path), selected);
  clearBuf(scrbuf);
  file = fopen (name, "rb");
  size = filesize(name);
  printf("%d\n", size);
  filebuf = (char*) malloc(size);
  fread(filebuf, 1, size, file);
  clearBuf(scrbuf);
  x = y = 0;
  current = size;
  for (i = 0; i < size; i++) {
    ch = filebuf[i];
    if (ch == 0x0A) {
      x = 0;
      y += 12;
      continue;
    }
    if (ch == 0x0D) {
      continue;
    }
    putChar(scrbuf, x, y, ch);
    x += 8;
    if (x > 312) {
      x = 0;
      y += 12;
    }
    if (y > 228) {
      current = i + 1;
      break;
    }
  } 
  refresh(scrbuf);
  while (current < size && !isKeyPressed(KEY_NSPIRE_ESC)) {
    if (isKeyPressed(KEY_NSPIRE_DOWN)) {
      scrollScreenUp(scrbuf, tmpbuf, 12);
      x = 0;
      y = 228;
      while (y <= 228) {
        ch = filebuf[current];
        if (ch == 0x0A) {
          y += 12;
          current++;
          continue;
        }
        if (ch == 0x0D) {
          current++;
          continue;
        }
        putChar(scrbuf, x, y, ch);
        current++;
        x += 8;
        if (x > 312) {
          x = 0;
          y += 12;
        }
      }
      refresh(scrbuf); 
    }
  }
  refresh(scrbuf);
  while (!isKeyPressed(KEY_NSPIRE_ESC));
  free(scrbuf);
  free(tmpbuf);
  free(filebuf);
  return 0;
}
